/* $Id: cm17a.h,v 1.9 1999/08/04 00:21:44 chrisf Exp $ */

/*
Sparkler - An X10 FireCracker (CM17A) tester for the PalmPilot
Copyright (C) 1999 Chris Faherty

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __CM17A_H__
#define __CM17A_H__

/*
 * It's actually only 40 bits, but I need to make sure I have a standby state
 * at the end of the last bit.
 */
#define CM17A_BITS 41

#define CM17A_HDR 0xd5aa
#define CM17A_FTR 0xad

#define CM17A_ON 0x0000
#define CM17A_OFF 0x0020
#define CM17A_DIM 0x0098
#define CM17A_BRIGHT 0x0088

#define CM17A_A 0x6000
#define CM17A_B 0x7000
#define CM17A_C 0x4000
#define CM17A_D 0x5000
#define CM17A_E 0x8000
#define CM17A_F 0x9000
#define CM17A_G 0xa000
#define CM17A_H 0xb000
#define CM17A_I 0xe000
#define CM17A_J 0xf000
#define CM17A_K 0xc000
#define CM17A_L 0xd000
#define CM17A_M 0x0000
#define CM17A_N 0x1000
#define CM17A_O 0x2000
#define CM17A_P 0x3000

#define CM17A_1 0x0000
#define CM17A_2 0x0010
#define CM17A_3 0x0008
#define CM17A_4 0x0018
#define CM17A_5 0x0040
#define CM17A_6 0x0050
#define CM17A_7 0x0048
#define CM17A_8 0x0058
#define CM17A_9 0x0400
#define CM17A_10 0x0410
#define CM17A_11 0x0408
#define CM17A_12 0x0418
#define CM17A_13 0x0440
#define CM17A_14 0x0450
#define CM17A_15 0x0448
#define CM17A_16 0x0458

/*
 * Function prototypes
 */
Boolean cm17a_tick(void);
void cm17a_one(void);
void cm17a_zero(void);
void cm17a_standby(void);
void cm17a_reset(void);
void cm17a_restore(void);

#endif
