/* $Id: m68328.h,v 1.2 1999/07/26 22:35:50 chrisf Exp $ */

/*
Sparkler - An X10 FireCracker (CM17A) tester for the PalmPilot
Copyright (C) 1999 Chris Faherty

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*
 * This stuff is non-portable and comes from the SDK headers.  I just grabbed
 * the things I needed because I want to support multiple devices and I think
 * they would conflict.
 */

#ifndef __M68328_H__
#define __M68328_H__

/* Define location and setup for the 68328 Dragonball chip */
#define hwr68328Base 0xFFFFF000L 

typedef struct HwrDBallType {

    Byte        scr;                /* $000: System Control Register */
    Byte                                            ___filler1[0xFF];                 
    
    Word        csAGroupBase;       /* $100: Chip Select Group A Base Register */
    Word        csBGroupBase;       /* $102: Chip Select Group B Base Register */
    Word        csCGroupBase;       /* $104: Chip Select Group C Base Register */
    Word        csDGroupBase;       /* $106: Chip Select Group D Base Register */
    
    Word        csAGroupMask;       /* $108: Chip Select Group A Mask Register */
    Word        csBGroupMask;       /* $10A: Chip Select Group B Mask Register */
    Word        csCGroupMask;       /* $10C: Chip Select Group C Mask Register */
    Word        csDGroupMask;       /* $10E: Chip Select Group D Mask Register */
    
    DWord        csASelect0;        /* $110: Group A Chip Select 0 Register */
    DWord        csASelect1;        /* $114: Group A Chip Select 1 Register */
    DWord        csASelect2;        /* $118: Group A Chip Select 2 Register */
    DWord        csASelect3;        /* $11C: Group A Chip Select 3 Register */
    
    DWord        csBSelect0;        /* $120: Group B Chip Select 0 Register */
    DWord        csBSelect1;        /* $124: Group B Chip Select 1 Register */
    DWord        csBSelect2;        /* $128: Group B Chip Select 2 Register */
    DWord        csBSelect3;        /* $12C: Group B Chip Select 3 Register */
    
    DWord        csCSelect0;        /* $130: Group C Chip Select 0 Register */
    DWord        csCSelect1;        /* $134: Group C Chip Select 1 Register */
    DWord        csCSelect2;        /* $138: Group C Chip Select 2 Register */
    DWord        csCSelect3;        /* $13C: Group C Chip Select 3 Register */
    
    DWord        csDSelect0;        /* $140: Group D Chip Select 0 Register */
    DWord        csDSelect1;        /* $144: Group D Chip Select 1 Register */
    DWord        csDSelect2;        /* $148: Group D Chip Select 2 Register */
    DWord        csDSelect3;        /* $14C: Group D Chip Select 3 Register */
    
    Word        csDebug;            /* $150: Chip Select debug Register */
    Byte                                            ___filler2[0x200-0x152];        
    
    Word        pllControl;         /* $200: PLL Control Register */
    Word        pllFreqSel;         /* $202: PLL Frequency Select Register */
    Word        pllTest;            /* $204: PLL Test Register */
    Byte                                            __filler44;
    Byte        pwrControl;         /* $207: Power Control Register */
    
    Byte                                            ___filler3[0x300-0x208];
    
    Byte        intVector;          /* $300: Interrupt Vector Register */
    Byte                                            ___filler4;
    Word        intControl;         /* $302: Interrupt Control Register */
    Word        intMaskHi;          /* $304: Interrupt Mask Register HIGH word */
    Word        intMaskLo;          /* $306: Interrupt Mask Register LOW word */
    Word        intWakeupEnHi;      /* $308: Interrupt Wakeup Enable Register */
    Word        intWakeupEnLo;      /* $30A: Interrupt Wakeup Enable Register */
    Word        intStatusHi;        /* $30C: Interrupt Status Register HIGH word */
    Word        intStatusLo;        /* $30E: Interrupt Status Register LOW word */
    Word        intPendingHi;       /* $310: Interrupt Pending Register */
    Word        intPendingLo;       /* $312: Interrupt Pending Register */
    
    Byte                                             ___filler4a[0x400-0x314];
    
    Byte        portADir;           /* $400: Port A Direction Register */
    Byte        portAData;          /* $401: Port A Data Register */
    Byte                                            ___filler5;
    Byte        portASelect;        /* $403: Port A Select Register */
    
    Byte                                            ___filler6[4];
    
    Byte        portBDir;           /* $408: Port B Direction Register */
    Byte        portBData;          /* $409: Port B Data Register */
    Byte                                            ___filler7;
    Byte        portBSelect;        /* $40B: Port B Select Register */    
    
    Byte                                            ___filler8[4];
    
    Byte        portCDir;           /* $410: Port C Direction Register */
    Byte        portCData;          /* $411: Port C Data Register */
    Byte                                            ___filler9;
    Byte        portCSelect;        /* $413: Port C Select Register */    
    
    Byte                                            ___filler10[4];
    
    Byte        portDDir;           /* $418: Port D Direction Register */
    Byte        portDData;          /* $419: Port D Data Register */
    Byte        portDPullupEn;      /* $41A: Port D Pull-up Enable */
    Byte                                            ___filler11;
    Byte        portDPolarity;      /* $41C: Port D Polarity Register */
    Byte        portDIntReqEn;      /* $41D: Port D Interrupt Request Enable */
    Byte                                            ___filler12;
    Byte        portDIntEdge;       /* $41F: Port D IRQ Edge Register */
    
    Byte        portEDir;           /* $420: Port E Direction Register */
    Byte        portEData;          /* $421: Port E Data Register */
    Byte        portEPullupEn;      /* $422: Port E Pull-up Enable */
    Byte        portESelect;        /* $423: Port E Select Register */
    
    Byte                                            ___filler14[4];
    
    Byte        portFDir;           /* $428: Port F Direction Register */
    Byte        portFData;          /* $429: Port F Data Register */
    Byte        portFPullupEn;      /* $42A: Port F Pull-up Enable */
    Byte        portFSelect;        /* $42B: Port F Select Register */
    
    Byte                                            ___filler16[4];
    
    Byte        portGDir;           /* $430: Port G Direction Register */
    Byte        portGData;          /* $431: Port G Data Register */
    Byte        portGPullupEn;      /* $432: Port G Pull-up Enable */
    Byte        portGSelect;        /* $433: Port G Select Register */
    
    Byte                                            ___filler18[4];
    
    Byte        portJDir;           /* $438: Port J Direction Register */
    Byte        portJData;          /* $439: Port J Data Register */
    Byte                                            ___filler19;
    Byte        portJSelect;        /* $43B: Port J Select Register */
    
    Byte                                            ___filler19a[4];
    
    Byte        portKDir;           /* $440: Port K Direction Register */
    Byte        portKData;          /* $441: Port K Data Register */
    Byte        portKPullupEn;      /* $442: Port K Pull-up Enable */
    Byte        portKSelect;        /* $443: Port K Select Register */
    
    Byte                                            ___filler21[4];
    
    Byte        portMDir;           /* $448: Port M Direction Register */
    Byte        portMData;          /* $449: Port M Data Register */
    Byte        portMPullupEn;      /* $44A: Port M Pull-up Enable Register */
    Byte        portMSelect;        /* $44B: Port M Select Register */
    
    Byte                                            ___filler22[4];
    
    Byte                                            ___filler23[0x500-0x450];
    
    Word        pwmControl;         /* $500: PWM Control Register */
    Word        pwmPeriod;          /* $502: PWM Period Register */
    Word        pwmWidth;           /* $504: PWM Width Register */
    Word        pwmCounter;         /* $506: PWM Counter */
    
    Byte                                            ___filler24[0x600-0x508];
    
    Word        tmr1Control;        /* $600: Timer 1 Control Register */
    Word        tmr1Prescaler;      /* $602: Timer 1 Prescaler Register */
    Word        tmr1Compare;        /* $604: Timer 1 Compare Register */
    Word        tmr1Capture;        /* $606: Timer 1 Capture Register */
    Word        tmr1Counter;        /* $608: Timer 1 Counter Register */
    Word        tmr1Status;         /* $60A: Timer 1 Status Register */
    
    Word        tmr2Control;        /* $60C: Timer 2 Control Register */
    Word        tmr2Prescaler;      /* $60E: Timer 2 Prescaler Register */
    Word        tmr2Compare;        /* $610: Timer 2 Compare Register */
    Word        tmr2Capture;        /* $612: Timer 2 Capture Register */
    Word        tmr2Counter;        /* $614: Timer 2 Counter Register */
    Word        tmr2Status;         /* $616: Timer 2 Status Register */
    
    Word        wdControl;          /* $618: Watchdog Control Register */
    Word        wdReference;        /* $61A: Watchdog Reference Register */
    Word        wdCounter;          /* $61C: Watchdog Counter */
    
    Byte                                            ___filler25[0x700-0x61E];
    
    Word        spiSlave;           /* $700: SPI Slave Register */
    
    Byte                                            ___filler26[0x800-0x702];
    
    Word        spiMasterData;      /* $800: SPI Master Data Register */
    Word        spiMasterControl;   /* $802: SPI Master Control Register */
    
    Byte                                            ___filler27[0x900-0x804];
    
    Word        uControl;           /* $900: Uart Control Register */
    Word        uBaud;              /* $902: Uart Baud Control Register */
    Word        uReceive;           /* $904: Uart Receive Register */
    Word        uTransmit;          /* $906: Uart Transmit Register */
    Word        uMisc;              /* $908: Uart Miscellaneous Register */
    
    Byte                                            ___filler28[0xA00-0x90A];
    
    DWord        lcdStartAddr;      /* $A00: Screen Starting Address Register */
    Byte                                            ___filler29;
    Byte        lcdPageWidth;       /* $A05: Virtual Page Width Register */
    Byte                                            ___filler30[2];
    Word        lcdScreenWidth;     /* $A08: Screen Width Register */
    Word        lcdScreenHeight;    /* $A0A: Screen Height Register */
    Byte                                            ___filler31[0xA18-0xA0C];
    Word        lcdCursorXPos;      /* $A18: Cursor X Position */
    Word        lcdCursorYPos;      /* $A1A:    Cursor Y Position */
    Word        lcdCursorWidthHeight; /* $A1C: Cursor Width and Height */
    Byte                                            ___filler32;
    Byte        lcdBlinkControl;    /* $A1F: Blink Control Register */
    Byte        lcdPanelControl;    /* $A20: Panel Interface Control Register */
    Byte        lcdPolarity;        /* $A21: Polarity Config Register */
    Byte                                            ___filler33;                        
    Byte        lcdACDRate;         /* $A23: ACD (M) Rate Control Register */
    Byte                                            ___filler34;
    Byte        lcdPixelClock;      /* $A25: Pixel Clock Divider Register */
    Byte                                            ___filler35;
    Byte        lcdClockControl;    /* $A27: Clocking Control Register */
    Byte                                            ___filler36;
    Byte        lcdLastBufferAddr;  /* $A29: Last Buffer Address Register */
    Byte                                            ___filler37;
    Byte        lcdOctetTermCount;  /* $A2B: Octet Terminal Count Register */
    Byte                                            ___filler38;
    Byte        lcdPanningOffset;   /* $A2D: Panning Offset Register */
    Byte                                            ___filler39[3];
    Byte        lcdFrameRate;       /* $A31: Frame Rate Control Modulation Register */
    Word        lcdGrayPalette;     /* $A32: Gray Palette Mapping Register */
    Byte        lcdReserved;        /* $A34: Reserved */
    
    Byte                                            ___filler40[0xB00-0xA35];
    
    DWord        rtcHourMinSec;     /* $B00: RTC Hours, Minutes, Seconds Register */
    DWord        rtcAlarm;          /* $B04: RTC Alarm Register */
    DWord        rtcReserved;       /* $B08: RTC Reserved */
    Word        rtcControl;         /* $B0C: RTC Control Register */
    Word        rtcIntStatus;       /* $B0E: RTC Interrupt Status Register */
    Word        rtcIntEnable;       /* $B10: RTC Interrupt Enable Register */
    Word        stopWatch;          /* $B12: Stopwatch Minutes */
    
    } HwrDBallType;

typedef volatile HwrDBallType* HwrDBallPtr;

#endif
